/*


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/


void move_motors() { 

/*          
Figure out what poortion of the program we are in - broken up in 6 distinct parts
1 - LeadIn			
2 - RampUp
3 - Linear
4 - RampDown
5 - LeadOut
9 - Finished

//Figure out where we are in the program by the camera_fired and calculated start and end points by using the following variable
  keyframe[0]=0; //start frame
  keyframe[1]=lead_in; //beginning of ramp
  keyframe[2]=lead_in+rampval; //end of ramp, beginning of lieaar
  keyframe[3]=lead_in+camera_moving_shots-rampval;  //end or linear, beginning of rampdown
  keyframe[4]=lead_in+camera_moving_shots; //end of rampdown, beginning of leadout
  keyframe[5]=lead_in+camera_moving_shots+lead_out; //end of leadout, end of program
                  
*/

        if (camera_fired<keyframe[1]) { //Leadin
          program_progress=1;
          if (DEBUG_MOTOR) Serial.print("LeadIn ");
        }
        else if (camera_fired<keyframe[2]) {  //Rampup
          program_progress=2;
          if (DEBUG_MOTOR) Serial.print("Rampup ");
        }
        else if (camera_fired<keyframe[3]) {  //Linear
          program_progress=3;
          if (DEBUG_MOTOR) Serial.print("Linear "); 
        }
        else if (camera_fired<keyframe[4]) {  //RampDown
          program_progress=4;
          if (DEBUG_MOTOR) Serial.print("RampDn ");
        }
        else if (camera_fired<keyframe[5]) {  //Leadout
          program_progress=5;
          if (DEBUG_MOTOR) Serial.print("LeadOut ");
        }
        else {
         program_progress=9;   //Finished
        } 
 

//init our targets
FloatPoint fp;

if (DEBUG_MOTOR) {Serial.print("Shot ");Serial.print(camera_fired);Serial.print(";");}
//calculate our targets
fp.x = current_steps.x + motor_get_steps(0);
fp.y = current_steps.y + motor_get_steps(1);
fp.z = current_steps.z + motor_get_steps(2);
if (DEBUG_MOTOR) {Serial.print("B;");Serial.print(current_steps.x);Serial.print(";");Serial.print(current_steps.y);Serial.print(";");Serial.print(current_steps.z);Serial.print(";");}
set_target(fp.x,fp.y,fp.z); //we are in incremental mode to start abs is false
  if (DEBUG_MOTOR) {Serial.print("D;");Serial.print(delta_steps.x);Serial.print(";");Serial.print(delta_steps.y);Serial.print(";");Serial.print(delta_steps.z);Serial.print(";");}

//calculate feedrate - update this to be dynaimc based on settle window
feedrate_micros = calculate_feedrate_delay_1(); //caclulates micro delay based on available move time

//{Serial.print("Feedrate:");Serial.println(feedrate_micros);}

//VIDEO Loop
if (intval==3) {
 // if (feedrate_micros >250) dda_move(feedrate_micros-240);
 // else {
    //dda_move(9);
    //Serial.print("maxspeed");
  //}
 dda_move(feedrate_micros); 
}

//SMS Looop
else {
  feedrate_micros = min(feedrate_micros, 2000); //get a slow move, but not too slow, give the motors a chance to rest
  dda_move(feedrate_micros);
  Move_Engaged=false; //clear move engaged flag
}

if (DEBUG_MOTOR) {Serial.print("A;");Serial.print(current_steps.x);Serial.print(";");Serial.print(current_steps.y);Serial.print(";");Serial.print(current_steps.z);Serial.print(";");}
return;
}

long motor_get_steps(int motor)  {
  
long steps=0; //updated this and tested against 12 foot move with and inch or so of travel with a 50:1 gear ration - needed to get above 32000 steps before overflow

long cur_steps[3];
cur_steps[0]=current_steps.x;
cur_steps[1]=current_steps.y;
cur_steps[2]=current_steps.z;

 
 //if (DEBUG) Serial.print(motor);Serial.print("motor ");
        
   switch (program_progress) {
      case 1:  //Lead In - 0 Steps
             steps=0;
            if (DEBUG_MOTOR)  Serial.print(steps);
      break;
      
      case 2: //RampUp 
          steps=(float)((camera_fired-lead_in)*linear_steps_per_shot[motor]/rampval);
          if (DEBUG_MOTOR)  Serial.print(steps);
      break;
      
      case 3:  // Linear portion
          steps=(float)(motor_steps_end[motor]-ramp_params_steps[motor]-cur_steps[motor])/(keyframe[3]-camera_fired); //
          if (DEBUG_MOTOR)  Serial.print(steps);
       break;
      
      case 4:  // RampDown
            steps=(float)((motor_steps_end[motor]-cur_steps[motor])*2)/(keyframe[4]-camera_fired); //
            if (DEBUG_MOTOR) Serial.print(steps);
      break;
      
      case 5:  //Lead Out
              steps=0;
            if (DEBUG_MOTOR) Serial.print(steps);
      break;
      
      case 9:  //5 - finished	
      break;      
        
   }      

     if (DEBUG) Serial.print(";");
     return(steps);  
}  
  
  
