/*

(c) 2011 B.C. Burling eMotimo


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.



*/
/* 

 =========================================
PT_LCD_Buttons - Code for Menus and User Interface
 =========================================
 
*/
//char CZ1[]= "C-Next Z-Go Back";

void Reset_or_Use_Stored()
{
        if (first_time==1){
            lcd.empty();  
            draw(setup_str,4,1,3);//lcd.at(1,3,"C-Use Stored");
            draw(setup_str,5,2,5);//lcd.at(2,5,"Z-Reset");
            first_time=0;
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            disable_steppers();
            delay(prompt_time);
          }
        
        NunChuckQuerywithEC();
        NunChuckjoybuttons();
        button_actions_reset_stored(); 
        delay(1);
}

void button_actions_reset_stored()
{
      switch (c_button) 
      {

              case 1: // c on - use stored values
                          //user_input();
                          reset_prog=0; //not reset
                          lcd.empty();
                          lcd.at(1,1,"Using Set Params");
                          delay(prompt_time);
                          lcd.empty();
                          progstep_forward();
                          break;
              case 0:
                switch (z_button) // 
                {
                  case 1: // z button on - run the reset routine
                      //user_input();                    
                      reset_prog=1;
                      write_defaults_to_eeprom_memory(); //write to RAM and EEPROM
                      //restore_from_eeprom_memory();
                      //review_RAM_Contents();
                      lcd.empty();
                      draw(setup_str,6,1,3);//lcd.at(1,3,"Params Reset");
                      delay(prompt_time);
                      lcd.empty();
                      progstep_forward();
                  
                      
                      break;
        
                  default:
                      break;    
                }
              default:
                  break;   

      }
  
}


//Move to Start Point
void Move_to_Startpoint()
{
        if (first_time==1){
            lcd.empty();  
            lcd.bright(80);
            draw(setup_str,8,1,1);//lcd.at(1,1,"Move to Start Pt");
            draw(setup_str,14,2,6);//lcd.at(2,6,"C-Next");
            first_time=0;
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            delay(prompt_time);
            prev_joy_x_reading=0; //prevents buffer from moving axis from previous input 
            prev_joy_y_reading=0; 
          }
        
        NunChuckQuerywithEC();
        NunChuckjoybuttons();
        applyjoymovebuffer();
        dda_move(feedrate_micros);
        button_actions_move_start();  //read buttons, look for home set on c

}

void button_actions_move_start()
{
             switch (c_button) 
            {

              case 1: // c on
                          //user_input();
                          lcd.empty();
                          set_position(0.0, 0.0, 0.0); //for new motor commands - setting home
                          draw(setup_str,9,1,3);//lcd.at(1,3,"Start Pt. Set");
                          delay(prompt_time);
                          lcd.empty();
                          progstep_forward();
                          break;
              case 0:
                switch (z_button) //this would send us back to step 1
                {
                  case 1: // button on
                      //Don't allow this option for anything
                       //user_input();
                       break;
        
                  default:
                      break;    
                }
              default:
                  break;   

            }
  
}  

//Move to End Point
void Move_to_Endpoint()
{
        if (first_time==1){
            prev_joy_x_reading=0; //prevents buffer from moving axis from previous input 
            prev_joy_y_reading=0; 
          
            if( reset_prog==0 ) {
              lcd.empty();
              draw(setup_str,11,1,1);//lcd.at(1,1,"Moving to stored");
              draw(setup_str,12,2,4);//lcd.at(2,4,"end point");
                
      
              FloatPoint fp;
                fp.x = motor_steps_end[0];
                fp.y = motor_steps_end[1];
                fp.z = motor_steps_end[2];
             
              set_target(fp.x, fp.y, fp.z); 
	      dda_move(30); //send the motors home     
            
              lcd.empty();
              draw(setup_str,13,1,1);//lcd.at(1,1,"Confirm or Move");
              draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
              first_time=0;
              delay(prompt_time);
              NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step

            }
            else { //routine for just moving to end point if nothing was stored.
              lcd.empty();
              draw(setup_str,15,1,1);//lcd.at(1,1,"Move to End Pt.");
              draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
              first_time=0;
              delay(prompt_time);
              NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
              enable_steppers();
            }
          }
        
        NunChuckQuerywithEC();
        NunChuckjoybuttons();
        applyjoymovebuffer();
        dda_move(feedrate_micros);
        button_actions_move_end();  //read buttons, look for home set on c
        delayMicroseconds(200);
        //delay(1);
}

void button_actions_move_end()
{
  
            switch (c_button) {

              case 1: // con
                  switch (z_button) {
                  case 1: //con zon
                      break;
                      
                  case 0: //con zoff
                       //user_input();
                                              
                      //calculate_deltas();                       

                      motor_steps_end[0] = current_steps.x; //now signed storage
                      motor_steps_end[1] = current_steps.y;
                      motor_steps_end[2] = current_steps.z;
                      if (DEBUG_MOTOR) {Serial.println("motor_steps_end");Serial.print(motor_steps_end[0]);Serial.print(",");Serial.print(motor_steps_end[1]);Serial.print(",");Serial.print(motor_steps_end[2]);Serial.println();}                    
                      
                      lcd.empty();
                      draw(setup_str,16,1,3);//lcd.at(1,3,"End Point Set");
                      delay(prompt_time);
                      progstep_forward();
                      break;
                                           
                      }
             case 0: //coff
                  switch (z_button) {
                  case 1: //coff zon
                      //add new double check routine for spurious reads of z
                     //user_input();
                     delay(1);
                     NunChuckQuerywithEC();
                     NunChuckjoybuttons();
                     if (Nunchuck.zbutton()==1){
                       progstep_backward();
                     } 
                     else break;
                  case 0:  //coff zoff
                      break;
                  }
                  break;
                 default:
                      break;
            }
  
}  

///************entering new section

//Move to AUX End Point
void Enter_Aux_Endpoint()
{
        if (first_time==1){
          
             //routine for just moving to end point if nothing was stored.
              lcd.empty();
              draw(setup_str,63,1,1);//lcd.at(1,1,"Enter Aux End Pt");
              draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
              first_time=0;
              delay(prompt_time);
              lcd.empty();
              lcd.at(1,11,"Inches");
              lcd.at(2,12,"Steps");
              aux_dist=long(motor_steps_end[2]*10L)/47812L;
              
              NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
              //enable_steppers();
            
          }
        
        NunChuckQuerywithEC();
        NunChuckjoybuttons();

          aux_dist += joy_capture3();

          lcd.at(1,1,aux_dist/10);
          lcd.at(1,7,aux_dist%10);
          (motor_steps_end[2])=(aux_dist*47812L)/10;
          lcd.at(2,1,(long)(motor_steps_end[2]));
            //if (rampval <10)  lcd.at(1,8,"  ");  //clear extra if goes from 3 to 2 or 2 to  1
            //if (rampval<100)  lcd.at(1,9," ");  //clear extra if goes from 3 to 2 or 2 to  1

          //delay(50);
          button_actions_Enter_Aux_Endpoint();  //read buttons, look for c button press to set interval
          delay (prompt_delay);

        //delay(1);
}

void button_actions_Enter_Aux_Endpoint()
{
  
            switch (c_button) {

              case 1: // con
                  switch (z_button) {
                  case 1: //con zon
                      break;
                      
                  case 0: //con zoff
                       //user_input();
                                              
                      //calculate_deltas();                       

                      //motor_steps_end[2] = current_steps.z;
                      if (DEBUG_MOTOR) {Serial.println("motor_steps_end");Serial.print(motor_steps_end[0]);Serial.print(",");Serial.print(motor_steps_end[1]);Serial.print(",");Serial.print(motor_steps_end[2]);Serial.println();}                    
                      
                      lcd.empty();
                      draw(setup_str,64,1,2);//lcd.at(1,2,"Aux End Pt. Set"); //need to update this
                      delay(prompt_time);
                      progstep_forward();
                      break;
                                           
                      }
             case 0: //coff
                  switch (z_button) {
                  case 1: //coff zon
                      //add new double check routine for spurious reads of z
                     //user_input();
                     delay(1);
                     NunChuckQuerywithEC();
                     NunChuckjoybuttons();
                     if (Nunchuck.zbutton()==1){
                       progstep_backward();
                     } 
                     else break;
                  case 0:  //coff zoff
                      break;
                  }
                  break;
                 default:
                      break;
            }
  
}  


















///************exiting new section

//Set Camera Interval
void Set_Cam_Interval()
{
        if (first_time==1){
            lcd.empty();
            lcd.bright(80);
            draw(setup_str,17,1,1);//lcd.at(1,1,"Set Sht Interval");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,18,1,1);//lcd.at(1,1,"Intval:   .  sec");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            first_time=0;
          }
          
          
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          if (intval<20) joy_lock_count=0;
          intval += joy_capture3(); 
          intval=constrain(intval,3,6000); //remove the option for Ext Trigger right now
          //delay(40); //add all delays at the end
          if (intval==2) //run the Ext
            {
              draw(setup_str,19,1,8);//lcd.at(1,8," Ext.Trig");  
            }
          else if (intval==3) //run the video routine
            {
              draw(setup_str,20,1,8);//lcd.at(1,8," Video   ");  
            }
          else if (intval<10)
            {
              lcd.at(1,13," sec");
              lcd.at(1,8,"  0.");  
              lcd.at(1,10,intval/10);  
              lcd.at(1,12,intval%10);
            }
          else if (intval<100)
            {
              lcd.at(1,8,"  ");  
              lcd.at(1,10,intval/10);  
              lcd.at(1,12,intval%10);
            }
           else if (intval<1000) 
            {
              lcd.at(1,8," ");
              lcd.at(1,9,intval/10);  
              lcd.at(1,12,intval%10); 
            }
           else 
            {
              lcd.at(1,8,intval/10);  
              lcd.at(1,12,intval%10); 
            }
             
           
            
          button_actions_intval(intval);  //read buttons, look for c button press to set interval
          delay (prompt_delay);
          
}


void button_actions_intval(unsigned int intval)  {
//Serial.print ("entered action3 loop \r\n");
            switch (c_button) // looking for c button press to set interval
            {
              case 1: // con
                   //user_input();
                   interval = (long)intval*100; //tenths of a second to ms
                   //camera_exp_tm=100; 
                       if (intval==2) //means ext trigger
                         {
                             interval=6000;  //Hardcode this to 6.0 seconds are 10 shots per minute to allow for max shot selection
                         }
                        else if (intval==3) //means video, set very small exposure time
                        {
                             camera_exp_tm=5; //doesn't matter, we never call the shutter
                             interval=video_sample_ms;  //Hardcode this to ?? ms for our video update samples in feedrate calc
                        }


                   lcd.empty();
                               
                   draw(setup_str,21,1,3);//lcd.at(1,3,"Interval Set"); // try this to push correct character
                   delay(prompt_time);
                   lcd.empty();
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 1
                {
                  case 1: // z button on
                       //user_input();
                       progstep_backward();
                       break;
        
                  default:
                      break;    
                }
              default:
                  break;    
            }    

}

void Set_Static_Time()
{
        if (first_time==1){
            lcd.empty();
            draw(setup_str,22,1,1);//lcd.at(1,1,"Set Static Time");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,23,1,1);//lcd.at(1,1,"Stat_T:   .  sec");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            max_shutter=intval-2; //max shutter is .2 seconds less than interval
            if (intval==2) max_shutter=600;
            first_time=0;
          }
          
          
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          
          if (static_tm<20) joy_lock_count=0;
          static_tm += joy_capture3(); 
          static_tm=constrain(static_tm,1,max_shutter);
          
          
          if (intval==3)
            {
              draw(setup_str,24,1,8);//lcd.at(1,8," Video   ");  
            }
          
          else if (static_tm<10)
            {
              lcd.at(1,8,"  0.");  
              lcd.at(1,10,static_tm/10);  
              lcd.at(1,12,static_tm%10);
            }
           else if (static_tm<100)
            {
              lcd.at(1,8,"  ");  
              lcd.at(1,10,static_tm/10);  
              lcd.at(1,12,static_tm%10);
            }
           else if (static_tm<1000)
            {
              lcd.at(1,8," "); 
              lcd.at(1,9,static_tm/10);  
              lcd.at(1,12,static_tm%10); 
            }
           else
            {
              lcd.at(1,8,static_tm/10);  
              lcd.at(1,12,static_tm%10); 
            } 
          button_actions_stat_time(static_tm);  //read buttons, look for c button press to set interval
          delay (prompt_delay);
}

void button_actions_stat_time(unsigned int exposure)  {
            switch (c_button) // looking for c button press
            {
              case 1: // con
                   //user_input();
                   if (intval!=3)  camera_exp_tm=(long)static_tm*100; //want to get to ms, but this is already multipled by 10 // 3 is used for video mode
                  
                   lcd.empty();
                   
                 
                   draw(setup_str,25,1,1);//lcd.at(1,1,"Static Time Set"); // try this to push correct character
                   delay(prompt_time);
                   lcd.empty();
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 1
                {
                  case 1: // z button on
                       //user_input();
                       progstep_backward();
                       break;
        
                  default:
                      break;    
                }
              default:
                  break;    
            }    

}

void Set_Prefire_Time() //not currently used - just hardcode to .2 seconds in another loop
{
        if (first_time==1){
            lcd.empty();
            draw(setup_str,26,1,1);//lcd.at(1,1,"Set PreFire Time");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,27,1,1);//lcd.at(1,1," Pre_T:   .  sec");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            max_prefire=intval-static_tm-2; //total interval-static_tm
            if (intval==2) max_prefire = 200;
            first_time=0;
          }
          
          
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          
          prefire_time += joy_capture3();  
          prefire_time=constrain(prefire_time,0,max_prefire);
         

          if (prefire_time<10)
            {
              lcd.at(1,9," 0.");  
              lcd.at(1,10,prefire_time/10);  
              lcd.at(1,12,prefire_time%10);
            }
           else if (prefire_time<100)
            {
              lcd.at(1,9," ");  
              lcd.at(1,10,prefire_time/10);  
              lcd.at(1,12,prefire_time%10);
            }
           else 
            {
              lcd.at(1,9,prefire_time/10);  
              lcd.at(1,12,prefire_time%10); 
            }
            
          button_actions_stat_time(prefire_time);  //read buttons, look for c button press to set interval
          delay (prompt_delay);
}

void button_actions_prefire_time(unsigned int exposure)  {
            switch (c_button) // looking for c button press
            {
              case 1: // con
                   //user_input();
                
                   draw(setup_str,28,1,1);//lcd.at(1,1,"Prefire Time Set"); // try this to push correct character
                   delay(prompt_time);
                   lcd.empty();
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 1
                {
                  case 1: // z button on
                       //user_input();
                       progstep_backward();
                       break;
        
                  default:
                      break;    
                }
              default:
                  break;    
            }    

}


void Set_Ramp()
{
        if (first_time==1){
            lcd.empty();
            draw(setup_str,29,1,1);//lcd.at(1,1,"    Set Ramp");
            delay(prompt_time);
            NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
            lcd.empty();
            draw(setup_str,30,1,1);//lcd.at(1,1,"Ramp:     Frames");
            draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
            first_time=0;
        }
            
          
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          if (rampval<20) joy_lock_count=0;
          rampval += joy_capture3();
          if (rampval<=0) {rampval=500;}
          if (rampval>500) {rampval=500;}
          //rampval=constrain(rampval,1,500); // 
          lcd.at(1,7,rampval); 
            if (rampval <10)  lcd.at(1,8,"  ");  //clear extra if goes from 3 to 2 or 2 to  1
            if (rampval<100)  lcd.at(1,9," ");  //clear extra if goes from 3 to 2 or 2 to  1

          //delay(50);
          button_actions_rampval();  //read buttons, look for c button press to set interval
          delay (prompt_delay);
}    

void button_actions_rampval()  {

            switch (c_button) // looking for c button press 
            {
              case 1: // 
                  //user_input();
                  //we actually don't store anything here - wait for final confirmation to seteverything
            
                   lcd.empty();
                   draw(setup_str,31,1,5);//lcd.at(1,5,"Ramp Set");
                   delay(prompt_time);
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back
                {
                  case 1: // button on
                       //user_input();
                       progstep_backward();
                       
                       break;
                  default:
                      break;    
                }
              default:
                  break;    
           }    
}


void Set_Duration() //This is really setting frames
{
           if (first_time==1){
             lcd.empty();     
             //          1234567890123456
             draw(setup_str,32,1,5);//lcd.at(1,5,    "Set Move");
             draw(setup_str,33,2,5);//lcd.at(2,5,    "Duration");
             delay(prompt_time*1.5);
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             lcd.empty();
             draw(setup_str,34,1,10);//lcd.at(1,9,"H:MM:SS");
             if (intval>3) lcd.at(2,11,"Frames");
             else draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
             first_time=0;
           }
  
          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          
          if (intval==3) { //video
              if (overaldur < 11) overaldur += joy_capture3();
              else overaldur += joy_capture3();
              //constrain(overaldur,2,10000);
              if (overaldur<=0) {overaldur=10000;}
              if (overaldur>10000) {overaldur=1;}
              calc_time_remain_dur_sec ();
              display_time(1,1);
          }
          else { //sms
              if (camera_moving_shots < 11) camera_moving_shots += joy_capture3();
              else camera_moving_shots += joy_capture3();
              if (camera_moving_shots<=9) {camera_moving_shots=10000;}
              if (camera_moving_shots>10000) {camera_moving_shots=10;}
              //camera_moving_shots=constrain(camera_moving_shots,10,10000);
              camera_total_shots=camera_moving_shots; //we add in lead in lead out later
              calc_time_remain ();
              display_time(1,1);
          }
          
      
          if (intval>3) {
              if (camera_total_shots<100)
                {
                  lcd.at(2,7,camera_total_shots);  
                  lcd.at(2,4,"   ");
                }
              else if (camera_total_shots<1000)
                {
                  lcd.at(2,6,camera_total_shots);  
                  lcd.at(2,4,"  ");
                }
              else if (camera_total_shots<10000)
                {
                  lcd.at(2,5,camera_total_shots);  
                  lcd.at(2,4," ");
                }
              else 
                {
                  lcd.at(2,4,camera_total_shots);  
                }
          }
          
          button_actions_overaldur();  //read buttons, look for c button press to set overall time 
          delay (prompt_delay);
}

void button_actions_overaldur()  {
//Serial.print ("entered action3 loop \r\n");
            switch (c_button) // looking for c button press 
            {
              case 1: // 
                   //user_input();
                         
                   lcd.empty();
                   draw(setup_str,35,1,3);//lcd.at(1,3,"Duration Set");
                   delay (prompt_time);
                   progstep_forward();
                   break;
   
              case 0:
                  switch (z_button) //this would send us back to step 5
                {
                  case 1: // button on
                       //user_input();
                       progstep_backward();
                       break;
                  default:
                      
                      break;    
                }
              default:
                  
                  break;    
           }    
}


void Set_LeadIn_LeadOut()
{
    
          if (first_time==1){
             lcd.empty();     
             draw(setup_str,36,1,1);//lcd.at(1,1,"Set Static Lead");
             draw(setup_str,37,2,2);//lcd.at(2,2,"In/Out Frames");
             delay(prompt_time);
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             lcd.empty();
             draw(setup_str,38,1,6);//lcd.at(1,1,"In -    Out");
             draw(setup_str,3,2,1);//lcd.at(2,1,CZ1);
             first_time=0;
             lcd.at(1,9,lead_out);
             cursorpos=1;
           }

          NunChuckQuerywithEC();
          NunChuckjoybuttons();
          cursorpos += joy_capture_x1();
          cursorpos = constrain(cursorpos,1,2);
          if (cursorpos==2) lcd.pos(1,13);
          
          if (cursorpos==1){ //update lead in

              lcd.cursorOff();
              lead_in += joy_capture3();
              if (lead_in<1) {lead_in=5000;}
              if (lead_in>5000) {lead_in=1;}
              lcd.at(1,1,lead_in);
              
                            
              if (lead_in<10) { lcd.at(1,2,"   ");}
              if (lead_in<100) { lcd.at(1,3,"  ");}
              if (lead_in<1000) { lcd.at(1,4," ");}
              lcd.cursorBlock();
          }
          
          else { //update leadout
                       
              lcd.cursorOff(); 
              lead_out += joy_capture3();
              if (lead_out<1) {lead_out=5000;}
              if (lead_out>5000) {lead_out=1;}
              lcd.at(1,9,lead_out);
              
                           
              if (lead_out<10) { lcd.at(1,10,"   ");}
              if (lead_out<100) { lcd.at(1,11,"  ");}
              if (lead_out<1000) { lcd.at(1,12," ");}
              lcd.cursorBlock();
          }

          
          button_actions_lead_in_out();  //read buttons, look for c button press to ramp
          delay (prompt_delay);
}


void button_actions_lead_in_out()  {
            switch (c_button) // looking for c button press
            {
              case 1: // 
                   //user_input();
                   lcd.cursorOff();
                   camera_total_shots=camera_moving_shots+lead_in+lead_out;
                   //  prefire_time=2; //hardcode this value unless we want to prompt later

           
                   lcd.empty();
           
                   draw(setup_str,39,1,1);//lcd.at(1,1,"Lead Frames Set");
                   
                  
                  if (intval==3) {
                    //if (intval==3) camera_moving_shots=(overaldur*1000L)/interval; //figure out moving shots based on duration for video only
                    camera_moving_shots=500; //hardcode this and back into proper interval - this is XXX segments per sequence
                    interval=overaldur*1000L/camera_moving_shots;   //This give us 10 ms for a 10 second shot or 100ms for a 100 ms shot
                    camera_total_shots=camera_moving_shots+lead_in+lead_out; //good temp variable for display
                  }
                  
                   
                  //fix issues with ramp that is too big 
                  if( rampval*3 > camera_moving_shots ) {    // we have an issue where the ramp is to big can be 2/3 of total move, but not more.
                        rampval=camera_moving_shots/3; //set to 1/3 up and 1/3 down (2/3) of total move)
                  }     
                  
                  
                //Set keyframe points for program to help with runtime calcs
                  keyframe[0]=0; //start frame
                  keyframe[1]=lead_in; //beginning of ramp
                  keyframe[2]=lead_in+rampval; //end of ramp, beginning of lieaar
                  keyframe[3]=lead_in+camera_moving_shots-rampval;  //end or linear, beginning of rampdown
                  keyframe[4]=lead_in+camera_moving_shots; //end of rampdown, beginning of leadout
                  keyframe[5]=lead_in+camera_moving_shots+lead_out; //end of leadout, end of program
                  
                  if (DEBUG_MOTOR) {
                      for (int i=0; i < 6; i++){
                          Serial.print("Keyframe");Serial.print(i);Serial.print("_");Serial.println(keyframe[i]);
                      }
                  }     
                      

                   //linear_steps_per_shot [3] /this is where we figure out what our linear steps should be by motor - this is now signed
                   
                   //This is for the linear portion, each array value is for a motor.
                
                   for (int i=0; i < MOTORS; i++){
                       linear_steps_per_shot[i] = motor_steps_end[i]/(camera_moving_shots-rampval); //This assumes ramp is equal on either side   SIGNED!!!
                       if (DEBUG_MOTOR) {Serial.print("LinSteps/Shot_");Serial.print(i);Serial.print("_");Serial.println(linear_steps_per_shot[i]);}
                   }
                   
                   //This is to calc the steps at the end of rampup for each motor.  Each array value is for a motor                   
                   
                   for (int i=0; i < MOTORS; i++){
                       ramp_params_steps[i] = 0.5*rampval*linear_steps_per_shot[i]; //steps at end of ramping target
                       if (DEBUG_MOTOR) {Serial.print("Ramp_Steps_");Serial.print(i);Serial.print("_");Serial.println(ramp_params_steps[i]);}
                   }
                   
       
                   delay (prompt_time);
                   draw(setup_str,40,1,1);//lcd.at(1,1," Going to Start"); //Moving back to start point
                   digitalWrite(MS1, HIGH); //ensure microstepping before jog back home
                   digitalWrite(MS2, HIGH);
                   digitalWrite(MS3, HIGH);
                   
                   

                   FloatPoint fp;
                      fp.x = 0.0;
                      fp.y = 0.0;
                      fp.z = 0.0;
                   set_target(fp.x, fp.y, fp.z); 
		   dda_move(30); //send the motors home

                   write_all_ram_to_eeprom(); //set this here to allow us to rerun this program from this point if we just want to turn it on reveiw and go
                   //restore_from_eeprom_memory();
                   if (DEBUG) review_RAM_Contents();
                   
                   delay(prompt_time);
                   disable_steppers();
                   NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
                   progstep_forward();
                   break;
    
              case 0:
                  switch (z_button) //this would send us back
                {
                  case 1: // button on
                       lcd.cursorOff();
                       //user_input();
                       progstep_backward();
                       break;
                  default:
                      break;    
                }
              default:
                  break;    
           }    
}




void Review_Confirm()
{
              
           if (first_time==1){
             lcd.empty();     
             draw(setup_str,41,1,4);//lcd.at(1,4,"Review and");
             draw(setup_str,42,2,2);//lcd.at(2,2,"Confirm Setting");
             //delay(prompt_time);
             delay(500);
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             delay(100);
             lcd.empty();
             first_time=0;
             diplay_last_tm =millis();
             reviewprog = 1;
           }
          
          if ((millis()-diplay_last_tm) >1200){
       
              reviewprog ++;
              diplay_last_tm =millis();
              if (reviewprog >4) reviewprog=1;
          }
          
          switch (reviewprog)
          {
            case 1:   // 
              lcd.empty();
              draw(setup_str,43,1,1);//lcd.at(1,1,"Pan Steps:");
              draw(setup_str,44,2,1);//lcd.at(2,1,"Tilt Steps:");
              //lcd.at(1,12,motor_steps[0]);
              lcd.at(1,12,(int)linear_steps_per_shot[0]);
              lcd.at(2,12,(int)linear_steps_per_shot[1]);
            break;
            
            case 2:   // 
              lcd.empty();
              draw(setup_str,45,1,1);//lcd.at(1,1,"Cam Shots:");
              draw(setup_str,46,2,1);//lcd.at(2,1,"Time:"); 
              lcd.at(1,12,camera_total_shots);
              calc_time_remain();
              display_time(2,6);
            break;
            
            case 3:   // 
              lcd.empty();
              draw(setup_str,47,1,6);//lcd.at(1,6,"Ready?");
              draw(setup_str,48,2,2);//lcd.at(2,2,"Press C Button");
            break;            
            case 4:   // 
              //lcd.empty();
              lcd.at(1,1,"StartDly:    min");
              lcd.at(2,2,"Press C Button");
              if (start_delay_min<20) joy_lock_count=0;
              start_delay_min += joy_capture3();
              if (start_delay_min<0) {start_delay_min=500;}
              if (start_delay_min>500) {start_delay_min=0;}
              lcd.at(1,11,start_delay_min); 
               // if (start_delay_min <10)  lcd.at(1,8,"  ");  //clear extra if goes from 3 to 2 or 2 to  1
               // if (start_delay_min <100)  lcd.at(1,9," ");  //clear extra if goes from 3 to 2 or 2 to  1
          
              
            break;
            
          }//end switch
          

          NunChuckQuerywithEC();
          NunChuckjoybuttons();
   
          if (abs(joy_y_axis)>20) {
            reviewprog=4;
            diplay_last_tm =millis();
          }
          

          
          button_actions_review();
          delay(100);

         
}






void button_actions_review()  {
            switch (c_button) // looking for c button press start
            {
              case 1: // 
                   //user_input();
                   lcd.empty();
                   
                   if (start_delay_min>0) {
                     lcd.at(1,2,"Delaying Start");
                     delay (start_delay_min*60L*1000L);
                     lcd.empty();
                   }
                   
                   enable_steppers();

                   
                   draw(setup_str,49,1,1);//lcd.at(1,1,"Program Running");
                   delay(prompt_time/3);
                   if (intval==2) {
                     //SetupInputInterruptPin2HighFalling();
                     //SetupInputInterruptPin2LowRising();
                     SetupInputInterruptPin3HighFalling();
                     //SetupInputInterruptPin3LowRising();
                     lcd.at(2,1,"Waiting for Ext.");
                   }
                   else
                   {
                     Program_Engaged=true;
                     Interrupt_Fire_Engaged=true; //just to start off first shot immediately
                   }
                   interval_tm = 0; //set this to 0 to immediately trigger the first shot 
                   
                   if (intval>3) { //SMS Mode
                     lcd.empty(); //clear for non video
                     progstep=50; //  move to the main programcamera_real_fire
                   }
                   else   {
                     //lcd.empty(); //leave up for video
                     progstep=51; 
                   }
                   //lcd.bright(100); //e
                   lcd_backlight_cur= 100;
                   first_time=1;
                   lcd.bright(20);
                   break;
    
              case 0:
                  switch (z_button) //this would send us back to step 6
                {
                  case 1: // button on
                       //user_input();
                       progstep_backward();
                       break;
                  default:
                      break;    
                }
              default:
                  break;    
           }    
}




void progstep_forward()
{
first_time=1;
progstep++;
delay(100);
NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
}

void progstep_backward()
{
first_time=1;
if (progstep>0) progstep--;
else progstep=0;
delay(100);
NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
}



void button_actions90()  { //repeat
            switch (c_button) // looking for c button press start
            {
              case 1: // 
                   //user_input();
                   disable_steppers();
                   //Program_Engaged=true;
                   camera_fired = 0;   
                   lcd.bright(100);         
                   progstep=3; //  move to the main program at the interval setting
                   first_time=1;
                   delay(prompt_time);
                   NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
                   //lcd.bright(0); //run in dimmed mode
                   //lcd_backlight_cur= 0;
                   break;
     
           }    
}





int joy_capture2() //captures joystick input
{
      prompt_delay=(500-5*abs(joy_y_axis));
      //Serial.print("slow");Serial.println(prompt_delay);
      return -1*constrain(map(joy_y_axis,-20,20,-1,2),-1,1);
 }

int joy_capture3() //captures joystick input and conditions it for UI
{

  if (joy_lock_count>245){ //really really fast
      //Serial.println("reallyreallyfast");
      prompt_delay=0;
      return -1*map(joy_y_axis,-55,55,-40,40);  
    }
  if (joy_lock_count>50){ //really fast
      //Serial.println("reallyfast");
      prompt_delay=10;
      return -1*map(joy_y_axis,-100,100,-10,10);
    }
    else if (joy_lock_count>20){ //pretty fast
      //Serial.println("prettyfast");
      prompt_delay=70;
      return -1*map(joy_y_axis,-80,80,-10,10);
    }
    else if (abs(joy_y_axis)>10){ //go variable add delay which we run later
      prompt_delay=(500-6*abs(joy_y_axis));
      if (prompt_delay<0) prompt_delay=15;
      //Serial.print("slow");Serial.println(prompt_delay);
      return -1*constrain(map(joy_y_axis,-20,20,-1,2),-1,1);
      
    }
    else { //null loop
      //Serial.println("nullloop");
      prompt_delay=0;
      return (0);
    }
}
int joy_capture_x1() //captures joystick input
{
  int returned_val=0;  
  returned_val=map(joy_x_axis,-80,80,-5,6);
  //Serial.print(returned_val);
  if (abs(returned_val)>3) delay(150);
  return returned_val;
}


void display_status()  {
  //1234567890123456
  //1234567890123456
  //XXXX/XXXX LeadIn      LeadOT Rampup RampDn, Pause
  //HH:MM:SS  XX.XXV 
    if (first_time==1){
             lcd.empty();     
             lcd.at(1,5,"/");//Add to one time display update
             //lcd.at(2,3,":  :      .  V");//Add to one time display update
             //lcd.at(2,3,":");
             //lcd.at(2,6,":");
             lcd.at(2,13,".");
             lcd.at(2,16,"v");
             NunChuckQuerywithEC(); //  Use this to clear out any button registry from the last step
             //lcd.empty();
             first_time=0;
     }
//update upper left camera fired/total shots   
  if (camera_fired<10) lcd.at(1,4,camera_fired);
  else if (camera_fired<100) lcd.at(1,3,camera_fired);
  else if (camera_fired<1000) lcd.at(1,2,camera_fired);
  else lcd.at(1,1,camera_fired);

  lcd.at(1,6,camera_total_shots); 
 
//Update program progress secion - upper right  

switch (program_progress) {
      case 1: 
        draw(setup_str,51,1,11);//lcd.at(1,11,"LeadIn"); 
      break;
         
      case 2: 
        draw(setup_str,52,1,11);//lcd.at(1,11,"RampUp");
      break;
      
      case 3: 
        draw(setup_str,53,1,11);//lcd.at(1,11,"Linear");
      break;
      
      case 4:  
        draw(setup_str,54,1,11);//lcd.at(1,11,"RampDn"); 
      break;
      
      case 5:  
        draw(setup_str,55,1,11);//lcd.at(1,11,"LeadOT");
      break;
      
     
      case 9: 
        draw(setup_str,56,1,11);//lcd.at(1,11,"Finish");  
      break;      
        
   }        

//Update Run Clock
calc_time_remain();
display_time(2,1);

//Do multiple reads of the battery and average
int batteryread=0;
for (int i=0; i<3; i++){
  batteryread += analogRead(0); // 
 }
  batteryread = batteryread/3;

int batt1= (batteryread/51); //  51 point per volt
int batt2= ((batteryread%51)*100)/51; //3 places off less the full decimal

if (batt1<10){
      lcd.at(2,11,"0");
      lcd.at(2,12,batt1);
    }
else lcd.at(2,11,batt1);

if (batt2<10){
      lcd.at(2,14,"0");
      lcd.at(2,15,batt2);
    }
else lcd.at(2,14,batt2);

  if (POWERDOWN_LV) {
      if (batt1<10) {
          draw(setup_str,7,2,1); //lcd.at(2,1,"Low Power");
          batt_low_cnt++;
          
          if (batt_low_cnt >20) {
            //Stop the program and go to low power state
            disable_steppers();
            Program_Engaged=false;
            lcd.empty();
            draw(setup_str,60,1,1);//lcd.at(1,1,"Battery too low");
            draw(setup_str,61,2,1);//lcd.at(2,1,"  to continue");
            
          }
          
          first_time=1;
      }  
      else batt_low_cnt=0;
  }//end of powerdown if
}//end of display

void calc_time_remain () {
timeh=((((float)camera_total_shots-(float)camera_fired)*(float)interval)/3600000); //hours
timem=((((float)camera_total_shots-(float)camera_fired)*(float)interval)/60000)-(timeh*60); //minutes  - could use modulus, but more confusing
time_s=((((float)camera_total_shots-(float)camera_fired)*(float)interval)/1000)-(timeh*3600)-(timem*60);; //seconds
}

void calc_time_remain_dur_sec () {
timeh=((float)(overaldur)/3600); //hours
timem=((float)(overaldur)/60)-(timeh*60); //minutes  - could use modulus, but more confusing
time_s=((float)(overaldur)/1)-(timeh*3600)-(timem*60);; //seconds
}

void display_time (int row, int col) {
    lcd.at(row,col+2,":");
    lcd.at(row,col+5,":");  
    
    if (timeh<10){
      lcd.at(row,col," ");
      lcd.at(row,col+1,timeh);
    }
    else lcd.at(row,col,timeh);
    
    if (timem<10){
      lcd.at(row,col+3,"0");
      lcd.at(row,col+4,timem);
    }
    else lcd.at(row,col+3,timem);
    
    if (time_s<10){
      lcd.at(row,col+6,"0");
      lcd.at(row,col+7,time_s);
    }
    else lcd.at(row,col+6,time_s);
}

void load_lcd_buffer(const char *stringval[],int array_num) {
  memset(lcdbuffer1, '0', 16);
  strcpy_P(lcdbuffer1, (char*)pgm_read_word(&(stringval[array_num])));
  //lcd.at(col,row,lcdbuffer1);
  
}

void draw(const char *stringval[],int array_num,int col, int row) {
  memset(lcdbuffer1, '0', 16);
  strcpy_P(lcdbuffer1, (char*)pgm_read_word(&(stringval[array_num])));
  lcd.at(col,row,lcdbuffer1);
  
}

void pause_prog() 
{

            switch (c_button) // looking for c button press 
            {
              case 1: // 
                  switch (z_button) //
                  {
                    case 1: // button on
                         Program_Engaged=!Program_Engaged;
                         if (!Program_Engaged) draw(setup_str,62,1,11);//lcd.at(1,11," Pause");
 
                         else display_status(); //push the status up to indicate restart
                                                 
                         //set recovery eeprom in case we want to pick back up - future functionality
                         //eeprom_write(13, camera_fired); //write this in to allow us to pick up here 
                         //eeprom_write(79, current_steps.x);
                         //eeprom_write(83, current_steps.y);
                         //eeprom_write(87, current_steps.z);
                         //eeprom_write(91, progstep);


                         delay(500);
                         break;
                    default:
                        
                        break;    
                  }
   
              case 0:
                  switch (z_button) //this would send us back to step 5
                {
                  case 1: // button on

                       break;
                  default:
                      
                      break;    
                }
              default:
                  
                  break;    
           }    
}



